using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Drawing.Imaging;
using System.Drawing.Drawing2D;

namespace WindowsApplication1
{
	public class Form1 : System.Windows.Forms.Form
	{
		public class Sresult : IComparable
		{
			public double Sum = 0;
			public int Angle = 0;
			public int Shape = 0;
			public double Size = 0;
			public int CompareTo(object obj) 
			{
				if(obj is Sresult) 
				{
					Sresult s = (Sresult) obj;

					return Sum.CompareTo(s.Sum);
				}
				throw new ArgumentException("object is not a Sresult");    
			}
		}
		public class Mpoint
		{
			public double norm,r,theta;
			public int x,y;
		}

		public class Mshape
		{
			public int x,y;
			public ArrayList[] ptslist = new ArrayList[(int)MAngle];
			public string name;
			public Bitmap Image;
		}

		const int Angles = 360;
		const int MAngle = 360;//reducing this value will make shape detection faster but less accurate

		int step = 5;
		int MOE = 5;//margin of error

		int Npanels = 0, Npboxes = 0 , Nlabels = 0;
		int numshapes = 0;
		ArrayList KnownShapes = new ArrayList();

		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.PictureBox pictureBox2;
		private System.Windows.Forms.PictureBox pictureBox3;

		private System.Windows.Forms.Button AddLibraryButton;
		private System.Windows.Forms.Button LibLeftButton;
		private System.Windows.Forms.Button LibRightButton;
		private System.Windows.Forms.Button GoShapeButton;
		private System.Windows.Forms.Button LoadLibImgButton;
		private System.Windows.Forms.Button ClearLibButton;
		private System.Windows.Forms.Button SetShapeNameButton;
		private System.Windows.Forms.Button CompairButton;
		private System.Windows.Forms.Button LoadCompImgButton;

		private System.Windows.Forms.TextBox ShapeIndexTextBox;
		private System.Windows.Forms.TextBox ShapeNameTextBox;
		private System.Windows.Forms.TextBox PixelDistTextBox;
		private System.Windows.Forms.TextBox MOETextBox;

		private System.Windows.Forms.CheckBox OutAllCheckBox;
		private System.Windows.Forms.CheckBox MoveCenterCheckBox;

		private System.Windows.Forms.OpenFileDialog openFileDialog;

		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Panel panel3;
		private System.Windows.Forms.Panel panel4;
		private System.Windows.Forms.Panel panel5;
		private System.Windows.Forms.Panel panel6;

		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;

		private System.Windows.Forms.PictureBox pictureBox8;//this is the worst best pictureBox

		ArrayList ResultPanels = new ArrayList();
		ArrayList ResultLabels = new ArrayList();
		ArrayList ResultPictureBoxes = new ArrayList();
		private System.ComponentModel.IContainer components;

		public Form1()
		{
			InitializeComponent();
			MessageBox.Show("Welcome to Image Comparison 3.40\n\nThis Program is written and copyright by Brian Hume.", "Welcome...", MessageBoxButtons.OK,MessageBoxIcon.Information, MessageBoxDefaultButton.Button1, MessageBoxOptions.DefaultDesktopOnly);
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.pictureBox2 = new System.Windows.Forms.PictureBox();
			this.PixelDistTextBox = new System.Windows.Forms.TextBox();
			this.MOETextBox = new System.Windows.Forms.TextBox();
			this.AddLibraryButton = new System.Windows.Forms.Button();
			this.CompairButton = new System.Windows.Forms.Button();
			this.pictureBox3 = new System.Windows.Forms.PictureBox();
			this.ShapeNameTextBox = new System.Windows.Forms.TextBox();
			this.LibLeftButton = new System.Windows.Forms.Button();
			this.LibRightButton = new System.Windows.Forms.Button();
			this.OutAllCheckBox = new System.Windows.Forms.CheckBox();
			this.MoveCenterCheckBox = new System.Windows.Forms.CheckBox();
			this.ShapeIndexTextBox = new System.Windows.Forms.TextBox();
			this.GoShapeButton = new System.Windows.Forms.Button();
			this.SetShapeNameButton = new System.Windows.Forms.Button();
			this.LoadCompImgButton = new System.Windows.Forms.Button();
			this.LoadLibImgButton = new System.Windows.Forms.Button();
			this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
			this.panel1 = new System.Windows.Forms.Panel();
			this.pictureBox8 = new System.Windows.Forms.PictureBox();
			this.label6 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.panel5 = new System.Windows.Forms.Panel();
			this.ClearLibButton = new System.Windows.Forms.Button();
			this.panel3 = new System.Windows.Forms.Panel();
			this.panel4 = new System.Windows.Forms.Panel();
			this.panel2 = new System.Windows.Forms.Panel();
			this.label1 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.panel6 = new System.Windows.Forms.Panel();
			this.panel1.SuspendLayout();
			this.panel3.SuspendLayout();
			this.panel4.SuspendLayout();
			this.panel2.SuspendLayout();
			this.SuspendLayout();
			// 
			// pictureBox1
			// 
			this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
			this.pictureBox1.Location = new System.Drawing.Point(0, 0);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(361, 400);
			this.pictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize;
			this.pictureBox1.TabIndex = 0;
			this.pictureBox1.TabStop = false;
			// 
			// pictureBox2
			// 
			this.pictureBox2.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox2.Image")));
			this.pictureBox2.Location = new System.Drawing.Point(0, 0);
			this.pictureBox2.Name = "pictureBox2";
			this.pictureBox2.Size = new System.Drawing.Size(186, 139);
			this.pictureBox2.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize;
			this.pictureBox2.TabIndex = 2;
			this.pictureBox2.TabStop = false;
			// 
			// PixelDistTextBox
			// 
			this.PixelDistTextBox.Location = new System.Drawing.Point(56, 296);
			this.PixelDistTextBox.Name = "PixelDistTextBox";
			this.PixelDistTextBox.Size = new System.Drawing.Size(64, 20);
			this.PixelDistTextBox.TabIndex = 7;
			this.PixelDistTextBox.Text = "5";
			this.PixelDistTextBox.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.PixelDistTextBox_KeyPress);
			// 
			// MOETextBox
			// 
			this.MOETextBox.Location = new System.Drawing.Point(208, 296);
			this.MOETextBox.Name = "MOETextBox";
			this.MOETextBox.Size = new System.Drawing.Size(64, 20);
			this.MOETextBox.TabIndex = 8;
			this.MOETextBox.Text = "5";
			this.MOETextBox.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.MOETextBox_KeyPress);
			// 
			// AddLibraryButton
			// 
			this.AddLibraryButton.Location = new System.Drawing.Point(288, 248);
			this.AddLibraryButton.Name = "AddLibraryButton";
			this.AddLibraryButton.Size = new System.Drawing.Size(80, 24);
			this.AddLibraryButton.TabIndex = 9;
			this.AddLibraryButton.Text = "Add to library";
			this.AddLibraryButton.Click += new System.EventHandler(this.AddLibraryButton_Click);
			// 
			// CompairButton
			// 
			this.CompairButton.Location = new System.Drawing.Point(112, 248);
			this.CompairButton.Name = "CompairButton";
			this.CompairButton.Size = new System.Drawing.Size(112, 24);
			this.CompairButton.TabIndex = 10;
			this.CompairButton.Text = "Compare Shape";
			this.CompairButton.Click += new System.EventHandler(this.CompairButton_Click);
			// 
			// pictureBox3
			// 
			this.pictureBox3.BackColor = System.Drawing.Color.DimGray;
			this.pictureBox3.Location = new System.Drawing.Point(0, 0);
			this.pictureBox3.Name = "pictureBox3";
			this.pictureBox3.Size = new System.Drawing.Size(200, 200);
			this.pictureBox3.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize;
			this.pictureBox3.TabIndex = 11;
			this.pictureBox3.TabStop = false;
			// 
			// ShapeNameTextBox
			// 
			this.ShapeNameTextBox.Location = new System.Drawing.Point(584, 304);
			this.ShapeNameTextBox.Name = "ShapeNameTextBox";
			this.ShapeNameTextBox.Size = new System.Drawing.Size(160, 20);
			this.ShapeNameTextBox.TabIndex = 12;
			this.ShapeNameTextBox.Text = "Shape Name";
			this.ShapeNameTextBox.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.ShapeNameTextBox_KeyPress);
			// 
			// LibLeftButton
			// 
			this.LibLeftButton.Location = new System.Drawing.Point(632, 248);
			this.LibLeftButton.Name = "LibLeftButton";
			this.LibLeftButton.Size = new System.Drawing.Size(24, 24);
			this.LibLeftButton.TabIndex = 13;
			this.LibLeftButton.Text = "<";
			this.LibLeftButton.Click += new System.EventHandler(this.LibLeftButton_Click);
			// 
			// LibRightButton
			// 
			this.LibRightButton.Location = new System.Drawing.Point(656, 248);
			this.LibRightButton.Name = "LibRightButton";
			this.LibRightButton.Size = new System.Drawing.Size(24, 24);
			this.LibRightButton.TabIndex = 14;
			this.LibRightButton.Text = ">";
			this.LibRightButton.Click += new System.EventHandler(this.LibRightButton_Click);
			// 
			// OutAllCheckBox
			// 
			this.OutAllCheckBox.Location = new System.Drawing.Point(8, 272);
			this.OutAllCheckBox.Name = "OutAllCheckBox";
			this.OutAllCheckBox.Size = new System.Drawing.Size(160, 24);
			this.OutAllCheckBox.TabIndex = 15;
			this.OutAllCheckBox.Text = "Output all shape results";
			// 
			// MoveCenterCheckBox
			// 
			this.MoveCenterCheckBox.Location = new System.Drawing.Point(144, 272);
			this.MoveCenterCheckBox.Name = "MoveCenterCheckBox";
			this.MoveCenterCheckBox.Size = new System.Drawing.Size(136, 24);
			this.MoveCenterCheckBox.TabIndex = 16;
			this.MoveCenterCheckBox.Text = "Move centers to (0,0)";
			this.MoveCenterCheckBox.Visible = false;
			// 
			// ShapeIndexTextBox
			// 
			this.ShapeIndexTextBox.Location = new System.Drawing.Point(688, 280);
			this.ShapeIndexTextBox.Name = "ShapeIndexTextBox";
			this.ShapeIndexTextBox.Size = new System.Drawing.Size(56, 20);
			this.ShapeIndexTextBox.TabIndex = 17;
			this.ShapeIndexTextBox.Text = "0";
			// 
			// GoShapeButton
			// 
			this.GoShapeButton.Location = new System.Drawing.Point(688, 248);
			this.GoShapeButton.Name = "GoShapeButton";
			this.GoShapeButton.Size = new System.Drawing.Size(56, 24);
			this.GoShapeButton.TabIndex = 18;
			this.GoShapeButton.Text = "Go";
			this.GoShapeButton.Click += new System.EventHandler(this.GoShapeButton_Click);
			// 
			// SetShapeNameButton
			// 
			this.SetShapeNameButton.Location = new System.Drawing.Point(520, 248);
			this.SetShapeNameButton.Name = "SetShapeNameButton";
			this.SetShapeNameButton.Size = new System.Drawing.Size(104, 24);
			this.SetShapeNameButton.TabIndex = 19;
			this.SetShapeNameButton.Text = "Set Shape Name";
			this.SetShapeNameButton.Click += new System.EventHandler(this.SetShapeNameButton_Click);
			// 
			// LoadCompImgButton
			// 
			this.LoadCompImgButton.Location = new System.Drawing.Point(8, 248);
			this.LoadCompImgButton.Name = "LoadCompImgButton";
			this.LoadCompImgButton.Size = new System.Drawing.Size(88, 24);
			this.LoadCompImgButton.TabIndex = 20;
			this.LoadCompImgButton.Text = "Load Image";
			this.LoadCompImgButton.Click += new System.EventHandler(this.LoadCompImgButton_Click);
			// 
			// LoadLibImgButton
			// 
			this.LoadLibImgButton.Location = new System.Drawing.Point(376, 248);
			this.LoadLibImgButton.Name = "LoadLibImgButton";
			this.LoadLibImgButton.Size = new System.Drawing.Size(72, 24);
			this.LoadLibImgButton.TabIndex = 21;
			this.LoadLibImgButton.Text = "Load Image";
			this.LoadLibImgButton.Click += new System.EventHandler(this.LoadLibImgButton_Click);
			// 
			// panel1
			// 
			this.panel1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.panel1.Controls.Add(this.pictureBox8);
			this.panel1.Controls.Add(this.label6);
			this.panel1.Controls.Add(this.label5);
			this.panel1.Controls.Add(this.panel5);
			this.panel1.Controls.Add(this.ClearLibButton);
			this.panel1.Controls.Add(this.MoveCenterCheckBox);
			this.panel1.Controls.Add(this.panel3);
			this.panel1.Controls.Add(this.CompairButton);
			this.panel1.Controls.Add(this.OutAllCheckBox);
			this.panel1.Controls.Add(this.LoadCompImgButton);
			this.panel1.Controls.Add(this.panel4);
			this.panel1.Controls.Add(this.panel2);
			this.panel1.Controls.Add(this.PixelDistTextBox);
			this.panel1.Controls.Add(this.MOETextBox);
			this.panel1.Controls.Add(this.AddLibraryButton);
			this.panel1.Controls.Add(this.ShapeNameTextBox);
			this.panel1.Controls.Add(this.LibLeftButton);
			this.panel1.Controls.Add(this.LibRightButton);
			this.panel1.Controls.Add(this.ShapeIndexTextBox);
			this.panel1.Controls.Add(this.GoShapeButton);
			this.panel1.Controls.Add(this.SetShapeNameButton);
			this.panel1.Controls.Add(this.LoadLibImgButton);
			this.panel1.Controls.Add(this.label1);
			this.panel1.Controls.Add(this.label4);
			this.panel1.Controls.Add(this.label3);
			this.panel1.Controls.Add(this.label2);
			this.panel1.Controls.Add(this.label7);
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(768, 328);
			this.panel1.TabIndex = 22;
			// 
			// pictureBox8
			// 
			this.pictureBox8.BackColor = System.Drawing.SystemColors.Control;
			this.pictureBox8.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox8.Image")));
			this.pictureBox8.Location = new System.Drawing.Point(296, 296);
			this.pictureBox8.Name = "pictureBox8";
			this.pictureBox8.Size = new System.Drawing.Size(189, 23);
			this.pictureBox8.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize;
			this.pictureBox8.TabIndex = 30;
			this.pictureBox8.TabStop = false;
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(504, 304);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(72, 24);
			this.label6.TabIndex = 29;
			this.label6.Text = "Shape Name";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(608, 280);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(80, 24);
			this.label5.TabIndex = 28;
			this.label5.Text = "Shape Number";
			// 
			// panel5
			// 
			this.panel5.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.panel5.Location = new System.Drawing.Point(276, -8);
			this.panel5.Name = "panel5";
			this.panel5.Size = new System.Drawing.Size(4, 344);
			this.panel5.TabIndex = 27;
			// 
			// ClearLibButton
			// 
			this.ClearLibButton.Location = new System.Drawing.Point(456, 248);
			this.ClearLibButton.Name = "ClearLibButton";
			this.ClearLibButton.Size = new System.Drawing.Size(56, 24);
			this.ClearLibButton.TabIndex = 26;
			this.ClearLibButton.Text = "Clear";
			this.ClearLibButton.Click += new System.EventHandler(this.ClearLibButton_Click);
			// 
			// panel3
			// 
			this.panel3.AutoScroll = true;
			this.panel3.AutoScrollMinSize = new System.Drawing.Size(222, 222);
			this.panel3.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.panel3.Controls.Add(this.pictureBox2);
			this.panel3.Location = new System.Drawing.Point(0, 16);
			this.panel3.Name = "panel3";
			this.panel3.Size = new System.Drawing.Size(224, 224);
			this.panel3.TabIndex = 24;
			// 
			// panel4
			// 
			this.panel4.AutoScroll = true;
			this.panel4.AutoScrollMinSize = new System.Drawing.Size(222, 222);
			this.panel4.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.panel4.Controls.Add(this.pictureBox3);
			this.panel4.Location = new System.Drawing.Point(520, 16);
			this.panel4.Name = "panel4";
			this.panel4.Size = new System.Drawing.Size(224, 224);
			this.panel4.TabIndex = 25;
			// 
			// panel2
			// 
			this.panel2.AutoScroll = true;
			this.panel2.AutoScrollMinSize = new System.Drawing.Size(222, 222);
			this.panel2.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.panel2.Controls.Add(this.pictureBox1);
			this.panel2.Location = new System.Drawing.Point(288, 16);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(224, 224);
			this.panel2.TabIndex = 23;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(4, 300);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(216, 24);
			this.label1.TabIndex = 22;
			this.label1.Text = "Pixel Dist.                           Margin of Error";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(288, 0);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(216, 16);
			this.label4.TabIndex = 1;
			this.label4.Text = "Library Addition Viewer";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(0, 0);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(216, 16);
			this.label3.TabIndex = 3;
			this.label3.Text = "Shape Comparison Image";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(520, 0);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(216, 16);
			this.label2.TabIndex = 12;
			this.label2.Text = "Shape Library Viewer";
			// 
			// label7
			// 
			this.label7.BackColor = System.Drawing.Color.White;
			this.label7.Location = new System.Drawing.Point(295, 295);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(191, 25);
			this.label7.TabIndex = 31;
			this.label7.Text = "Pixel Dist.                       Margin of Error";
			// 
			// panel6
			// 
			this.panel6.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.panel6.AutoScroll = true;
			this.panel6.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.panel6.Location = new System.Drawing.Point(0, 328);
			this.panel6.Name = "panel6";
			this.panel6.Size = new System.Drawing.Size(744, 189);
			this.panel6.TabIndex = 23;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.AutoScroll = true;
			this.ClientSize = new System.Drawing.Size(744, 517);
			this.Controls.Add(this.panel6);
			this.Controls.Add(this.panel1);
			this.MaximumSize = new System.Drawing.Size(752, 9999);
			this.MinimumSize = new System.Drawing.Size(752, 400);
			this.Name = "Form1";
			this.Text = "Image Comparison 3.40";
			this.panel1.ResumeLayout(false);
			this.panel3.ResumeLayout(false);
			this.panel4.ResumeLayout(false);
			this.panel2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		
		#region Shape Getting
		private Mshape GetShape(Bitmap a, Bitmap b, int sx ,int sy)
		{
			bool last = false;
			int i=0, j=0, x=sx, y=sy;
			int minx=a.Width,miny=a.Height,maxx=0,maxy=0;
			int BDist, Bi, Bj, Dist;
			Color White = Color.FromArgb(255,255,255);
			ArrayList pts = new ArrayList();
			pts.Add(new Point(x, y));

			while(true)
			{
				BDist=0;
				Bi=0;
				Bj=0;

				for (i = -1*step; i <= step; i++)
					for (j = -1*step; j <= step; j++)
					{
						Dist = (int)(10.0*Math.Sqrt((double)(i*i+j*j)));
						if (!(x+i <= 0 || x+i > b.Width-1 || y+j <= 0 || y+j > b.Height-1))
						{
							if (a.GetPixel(x+i,y+j)==White)
							{
								if (x+i > maxx) maxx = x+i;
								else if (x+i < minx) minx = x+i;
								if (y+j > maxy) maxy = y+j;
								else if (y+j < miny) miny = y+j;

								if  (BDist<Dist)
								{
									BDist = Dist;
									Bi=i;
									Bj=j;
								}
								b.SetPixel(x+i,y+j,White);
							}
							a.SetPixel(x+i,y+j,Color.Blue);
						}
					}

				if (Bi == 0 && Bj == 0 && !last && pts.Count > 2)//one no more points exist shape done
				{
					x = ((Point)pts[0]).X - (((Point)pts[1]).X - ((Point)pts[0]).X);
					y = ((Point)pts[0]).Y - (((Point)pts[1]).Y - ((Point)pts[0]).Y);
					last = true;
				}
				else if (Bi == 0 && Bj == 0 && last)
				{
					break;
				}
				else
				{
					x+=Bi;
					y+=Bj;
				}
				pts.Add(new Point(x,y));
			}
			
			if (maxy-10 < miny || maxx-10 < minx)return null;//if a shape is that small it would not turn our very well

			int mx=0, my=0;
			Mshape m = new Mshape();

			for (i = 0; i < pts.Count; i++)
			{
				mx += ((Point)pts[i]).X;
				my += ((Point)pts[i]).Y;
			}

			if (pts.Count > 1)
			{
				m.x = mx / (pts.Count);
				m.y = my / (pts.Count);
			}
			else
			{
				m.x = mx;
				m.y = my;
			}

			Bitmap mb = new Bitmap(maxx-minx, maxy-miny);//this is for when drawing the shape so it is an acurate representation
			for (i = minx; i < maxx; i++)
				for (j = miny; j < maxy; j++)
				{
					mb.SetPixel(i-minx,j-miny,b.GetPixel(i,j));
				}
			mb.SetPixel(m.x+1 - minx,m.y - miny,Color.Red);mb.SetPixel(m.x - minx,m.y+1 - miny,Color.Red);
			mb.SetPixel(m.x-1 - minx,m.y - miny,Color.Red);mb.SetPixel(m.x - minx,m.y-1 - miny,Color.Red);
			mb.SetPixel(m.x - minx,m.y - miny,Color.Red);
			m.Image = mb;

			return m;
		}
		#endregion

		#region ShapeScaning
		Mshape ScanShape(Mshape s, Bitmap b)
		{
			int centerx = s.x, centery = s.y;
			double angle;
			double dx,dy;//delta
			double px,py;
			int x,y;
			int i,j;
			double Adelta = 360 / (double)MAngle;
			Color White = Color.FromArgb(255,255,255);

			for (i = 0; i < MAngle; i++)
			{
				px = (double)centerx;
				py = (double)centery;
				angle = ((double)i * Adelta) / (MAngle/2) * Math.PI;
				dy = Math.Sin(angle)/2;
				dx = Math.Cos(angle)/2;
				s.ptslist[i] = new ArrayList();
				for (j = 0; j < b.Width*2 + b.Height*2; j++)
				{
					px += dx;
					py += dy;
					x = (int)px;
					y = (int)py;
					if (x <= 0 || x > b.Width-1 || y <= 0 || y > b.Height-1)break;
					if (b.GetPixel(x,y) == White)
					{
						Mpoint n = new Mpoint();
						n.x = x;
						n.y = y;
						n.theta = (i - 180) % 360;
						n.r = Math.Sqrt((double)((x-s.x)*(x-s.x)+(y-s.y)*(y-s.y)));
						s.ptslist[i].Add(n);
						px += step*2*dx;//step off the line since step is long
						py += step*2*dy;
						b.SetPixel(x,y,Color.White);
					}
				}
			}
			return s;
		}
		#endregion

		#region Shape Get Button
		private void AddLibraryButton_Click(object sender, System.EventArgs e)
		{
			Bitmap list = new Bitmap(pictureBox1.Image);
			//Bitmap show = new Bitmap(pictureBox1.Image);
			Bitmap show = new Bitmap((int)pictureBox1.Image.PhysicalDimension.Width, (int)pictureBox1.Image.PhysicalDimension.Height);
			Mshape s;
			
			int x,y;
			Color White = Color.FromArgb(255,255,255);
				
			for (x = 0; x < list.Width; x++)
				for (y = 0; y < list.Height; y++)
					if (list.GetPixel(x,y) == White)
					{
						pictureBox3.Image = show;
						s = GetShape(list,show,x,y);
						if (s == null) break;
						if (MoveCenterCheckBox.Checked)
						{
							s.x = 0;
							s.y = 0;
						}
						s = ScanShape(s,show);
						s.name = "Unnammed Shape #" + (++numshapes).ToString();
						KnownShapes.Add(s);
						pictureBox3.Refresh();
						show = new Bitmap((int)pictureBox1.Image.PhysicalDimension.Width, (int)pictureBox1.Image.PhysicalDimension.Height);
					}
			ShapeIndexTextBox.Text = "0";
			GoShapeButton_Click(sender,e);
		}
		#endregion

		#region Shape Result Improving
		ArrayList BestCompress(ArrayList m, int i)
		{
			ArrayList n = new ArrayList();
			int j;
			Mpoint p;
			if (m.Count == 0) {p = new Mpoint();p.r = -9999999;n.Add(p);return n;}

			for (j = 0; j < i; j++)
			{
				p = (Mpoint)m[j];
				n.Add(p);
			}

			return n;
		}

		double FindScaleingDiffRPoints(ArrayList m, ArrayList o)
		{
			double s = 0.0;
			int i = m.Count, j = o.Count,k;
			if (i > j)
				m = BestCompress(m,j);
			else if (i < j)
				o = BestCompress(o,i);

			for (k = 0; k < m.Count; k++)
			{
				s += ((Mpoint)m[k]).r / ((Mpoint)o[k]).r;
			}

			s /= (double)m.Count;

			if (m.Count == 0)return 1.0;
			if (s == double.NaN)return 1.0;

			return s;
		}

		double compairRPoints(ArrayList m, ArrayList o, double v)
		{
			double d = 1.0;
			int i = m.Count, j = o.Count,k;
			if (i > j)
			{
				m = BestCompress(m,j);
				d = d * (1 / (double)(Math.Abs(i-j)+1));
			}
			else if (i < j)
			{
				o = BestCompress(o,i);
				d = d * (1 / (double)(Math.Abs(i-j)+1));
			}
			for (k = 0; k < m.Count; k++)
			{
				if (((Mpoint)m[k]).r + MOE <= ((Mpoint)o[k]).r*v || ((Mpoint)m[k]).r - MOE >= ((Mpoint)o[k]).r*v) d -= 1/(m.Count)*d;
			}
			return d;
		}
		#endregion

		private void OutputLabel(double Bsum, int BAngle, int BestS, double bestSize, Mshape m, int l)
		{
			System.Windows.Forms.Panel X = ((Panel)ResultPanels[Npanels-1]);
			System.Windows.Forms.Label L = new Label();
			System.Windows.Forms.PictureBox I = new PictureBox();

			I.BackColor = Color.FromArgb(0x22,0,0);//the other images will be x22 in the red!
			I.Image = ((Mshape)KnownShapes[BestS]).Image;
			I.Location = new System.Drawing.Point(8, 80 + Nlabels * 88);
			I.Name = X.Name + "I" + Npboxes.ToString();
			I.Size = new System.Drawing.Size(64, 64);
			I.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			I.TabIndex = 0;
			I.TabStop = false;
			ResultPictureBoxes.Add(I);
			Npboxes++;
		
			L.Location = new System.Drawing.Point(80, 80 + Nlabels * 88);
			L.Name = "label2";
			L.Size = new System.Drawing.Size(608, 80);
			L.TabIndex = 0;
			L.TabStop = false;
			L.Text = "";

			I.BackColor = L.ForeColor = Color.FromArgb((int)(255 * (1.0 - Bsum/(double)MAngle)), 0, (int)(255 * (Bsum/(double)MAngle)));

			if (l == 0)
			{
				L.Text += "This shape is the MOST similar to a " + ((Mshape)KnownShapes[BestS]).name;
				if (Bsum/MAngle < 0.75)
					if (MessageBox.Show("This Shape is less than 75% similar to\nthe other shapes in the library.\nWould you like to add it to the library?","Add Non-Similar Shape?",MessageBoxButtons.YesNo) == DialogResult.Yes)
					{
						m.name = "New Shape";
						KnownShapes.Add(m);
					}
			}
			else
				L.Text += "This shape is the similar to a " + ((Mshape)KnownShapes[BestS]).name;

			L.Text += "\r\nOffset by (" + (m.x-((Mshape)KnownShapes[BestS]).x).ToString() + "," + (m.y-((Mshape)KnownShapes[BestS]).y).ToString()  + ")";

			if (MAngle-BAngle < 180)
				L.Text += "\r\nRotated CW :" + (MAngle-BAngle).ToString();
			else
				L.Text += "\r\nRotated CCW :" + BAngle.ToString();

			if (bestSize > 1.0)
				L.Text += "\r\nSize increased to %:" + (bestSize*100.0).ToString();
			else if (bestSize == 1.0)
				L.Text += "\r\nNo change in size.";
			else
				L.Text += "\r\nSize reduced to %:" + (bestSize*100.0).ToString();

			L.Text += "\r\nSimalarity %:" + (Bsum*100.0/MAngle).ToString() + "\r\n\r\n";

			ResultLabels.Add(L);
			Nlabels++;

			X.Controls.Add(L);
			X.Controls.Add(I);
			X.Height = 80 + Nlabels * 88;
		}

		#region Evaluate Shape
		private void Evaluate(Mshape m)
		{//use the theta or normal 
			int i,j,x;
			double amt;
			double SumAmt=0, VBsum =0,Bsum = 0;
			int VBAngle=0, BAngle=0;
			double AdvLenD=0;
			double VbestSize=1.0, bestSize=1.0;
			int VBestS = -1, BestS = -1;
			Mshape os;
			ArrayList results = new ArrayList();

			for (x = 0; x < KnownShapes.Count; x++)
			{
				os = (Mshape)KnownShapes[x];
				for (j = 0; j < MAngle; j++)
				{
					SumAmt = 0;
					for (i = 0; i < MAngle; i++)
					{
						if ((amt = compairRPoints(m.ptslist[i],os.ptslist[(i+j) % MAngle], 1.0)) > 0.01)SumAmt += amt;
						AdvLenD += FindScaleingDiffRPoints(m.ptslist[i],os.ptslist[(i+j) % MAngle]);
					}
					if (SumAmt > Bsum)
					{
						Bsum = SumAmt;
						BAngle = (int)(j * (360.0 / (double)MAngle)); 
						bestSize = 1.0;
						BestS = x;
					}

					AdvLenD = AdvLenD / MAngle;
					SumAmt = 0;
					for (i = 0; i < MAngle; i++)
					{
						if ((amt = compairRPoints(m.ptslist[i],os.ptslist[(i+j) % MAngle], AdvLenD)) > 0.01)SumAmt += amt;
						//					AdvLenD += FindScaleingDiffRPoints(m.ptslist[i],os.ptslist[(i+j) % MAngle]);
					}
					if (SumAmt > Bsum)
					{
						Bsum = SumAmt;
						BAngle = (int)(j * (360.0 / (double)MAngle)); 
						bestSize = AdvLenD;
						BestS = x;
					}
					AdvLenD = 0;
				}

				if (Bsum > VBsum)
				{
					VBsum = Bsum;
					VBAngle = BAngle;
					VBestS = BestS;
					VbestSize = bestSize;
				}
				if (OutAllCheckBox.Checked)
				{
					//OutputLabel(Bsum, BAngle, x, bestSize, m, 1);
					Sresult s = new Sresult();
					s.Angle = BAngle;
					s.Shape = x;
					s.Size = bestSize;
					s.Sum = Bsum;
					results.Add(s);
				}
				Bsum = 0;
				BAngle = 0;
				BestS = 0;
				bestSize = 0;
			}

			results.Sort();
			for (x = 0; x < results.Count-1; x++)
				if (((Sresult)results[x]).Shape != VBestS)
				{
					Sresult s = (Sresult)results[x];
					OutputLabel(s.Sum, s.Angle, s.Shape, s.Size, m, 1);
				}
			OutputLabel(VBsum, VBAngle, VBestS, VbestSize, m, 0);
		}

		private void CompairButton_Click(object sender, System.EventArgs e)
		{
			Bitmap bshape = new Bitmap(pictureBox2.Image);
			//Bitmap show = new Bitmap(pictureBox2.Image);
			Bitmap show = new Bitmap((int)pictureBox2.Image.PhysicalDimension.Width, (int)pictureBox2.Image.PhysicalDimension.Height);
			Mshape s;
			
			int x,y,i;
			Color White = Color.FromArgb(255,255,255);
				
			if (KnownShapes.Count == 0)
			{
				MessageBox.Show("Warning no shapes exist!","You must scan a shape or shapes before you can do a comparison.",MessageBoxButtons.OK);
					return;
			}

			Npanels = 0;

			for (x = 0; x < ResultLabels.Count; x++)
			{
				((Label)ResultLabels[x]).Dispose();
			}

			for (x = 0; x < ResultPictureBoxes.Count; x++)
			{
				((PictureBox)ResultPictureBoxes[x]).Dispose();
			}

			for (x = 0; x < ResultPanels.Count; x++)
			{
				((Panel)ResultPanels[x]).Dispose();
			}	
	
			ResultLabels.Clear();
			ResultPanels.Clear();
			ResultPictureBoxes.Clear();

			for (x = 0; x < bshape.Width; x++)
				for (y = 0; y < bshape.Height; y++)
					if (bshape.GetPixel(x,y) == White)
					{
						//pictureBox3.Image = show;
						s = GetShape(bshape,show,x,y);
						if (s == null) break;//if no shape is found it is porble an error in sobal
						if (MoveCenterCheckBox.Checked)
						{
							s.x = 0;
							s.y = 0;
						}
						s = ScanShape(s,show);
						s.name = "Comparitor";

						Npboxes = 0;
						Nlabels = 0;
						System.Windows.Forms.Panel P = new Panel();
						P.Left = 0;
						P.Top = 8;
						for (i = 0; i < Npanels; i++)
							P.Top += ((Panel)ResultPanels[i]).Height + 8;
						P.Width = panel6.Width - 24;// scroll bars are 16 + extra side thingys are 6 and im frounding up yay
						P.Height = panel6.Height - 8;
						P.Name = "P" + Npanels.ToString();
						P.Size = new System.Drawing.Size(P.Width, P.Height);
						P.Location = new System.Drawing.Point(P.Left, P.Top);
						P.TabIndex = 0;
						P.TabStop = false;
						
							System.Windows.Forms.PictureBox I = new PictureBox();
							I.BackColor = Color.FromArgb(0,0,0);//the other images will be x22 in the red!
							I.Image = s.Image;
							I.Location = new System.Drawing.Point(8, 8);
							I.Name = P.Name + "I" + Npboxes.ToString();
							I.Size = new System.Drawing.Size(64, 64);
							I.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
							I.TabIndex = 0;
							I.TabStop = false;
							ResultPictureBoxes.Add(I);
							Npboxes++;
							P.Controls.Add(I);

							System.Windows.Forms.Label L = new Label();
							L.Location = new System.Drawing.Point(80, 8);
							L.Name = "label2";
							L.Size = new System.Drawing.Size(608, 32);
							L.ForeColor = Color.FromArgb(0,0,0);
							L.Font = new Font(L.Font.Name, 18);
							L.TabIndex = 0;
							L.TabStop = false;
							L.Text = "Comparing This Shape.";//I should inc the label counter But that would offset my whole scheme
							P.Controls.Add(L);
							ResultLabels.Add(L);

						panel6.Controls.Add(P);
						ResultPanels.Add(P);
						Npanels++;

						Evaluate(s);
						show = new Bitmap((int)pictureBox2.Image.PhysicalDimension.Width, (int)pictureBox2.Image.PhysicalDimension.Height);
					}
		}
		#endregion

		private void drawshape(Mshape m)
		{
			Bitmap b = m.Image;
			//edit the shape if desired
			pictureBox3.Image = b;
			pictureBox3.Refresh();
		}

		private void GoShapeButton_Click(object sender, System.EventArgs e)
		{
			int sn = int.Parse(ShapeIndexTextBox.Text);
			if (sn >= KnownShapes.Count || sn < 0)
			{
				MessageBox.Show("Shape #"+sn.ToString()+" does not exist.");
				return;
			}
			drawshape((Mshape)KnownShapes[sn]);
			ShapeNameTextBox.Text = ((Mshape)KnownShapes[sn]).name;
		}

		private void SetShapeNameButton_Click(object sender, System.EventArgs e)
		{
			int sn = int.Parse(ShapeIndexTextBox.Text);
			if (sn >= KnownShapes.Count || sn < 0)
			{
				MessageBox.Show("Shape #"+sn.ToString()+" does not exist.");
				return;
			}
			((Mshape)KnownShapes[sn]).name = ShapeNameTextBox.Text;
		}

		private void LibRightButton_Click(object sender, System.EventArgs e)
		{
			int sn = int.Parse(ShapeIndexTextBox.Text);
			sn++;
			if (sn >= KnownShapes.Count || sn < 0)
				return;
			ShapeIndexTextBox.Text = sn.ToString();
			GoShapeButton_Click(sender,e);
		}

		private void LibLeftButton_Click(object sender, System.EventArgs e)
		{
			int sn = int.Parse(ShapeIndexTextBox.Text);
			sn--;
			if (sn >= KnownShapes.Count || sn < 0)
				return;
			ShapeIndexTextBox.Text = sn.ToString();
			GoShapeButton_Click(sender,e);
		}

		private void LoadCompImgButton_Click(object sender, System.EventArgs e)
		{
			if (openFileDialog.ShowDialog() == DialogResult.OK)
				pictureBox2.Image = Image.FromFile(openFileDialog.FileName);
		}

		private void LoadLibImgButton_Click(object sender, System.EventArgs e)
		{
			if (openFileDialog.ShowDialog() == DialogResult.OK)
				pictureBox1.Image = Image.FromFile(openFileDialog.FileName);
		}

		private void ShapeNameTextBox_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			if (e.KeyChar == (char)13 || e.KeyChar == (char)10)
				SetShapeNameButton_Click(sender, e);
		}

		private void MOETextBox_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			if (e.KeyChar == (char)13 || e.KeyChar == (char)10)
			{
				MOE = int.Parse(MOETextBox.Text);
				if (MOE > 20 || MOE < 0)
				{
					MessageBox.Show("Number of angles must be between 0 - 20");
					MOE = 4;
					PixelDistTextBox.Text = "4";
					return;
				}
			}
		}

		private void PixelDistTextBox_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			if (e.KeyChar == (char)13 || e.KeyChar == (char)10)
			{
				step = int.Parse(PixelDistTextBox.Text);
				if (step > 10 || step < 2)
				{
					MessageBox.Show("Step must be between 2 - 10");
					step = 5;
					PixelDistTextBox.Text = "5";
					return;
				}
			}
		}

		private void ClearLibButton_Click(object sender, System.EventArgs e)
		{
			if (KnownShapes.Count != 0)
				if (MessageBox.Show("Are you sure you wish to clear the list of shapes?","Clear shape library",MessageBoxButtons.YesNo) == DialogResult.Yes)
				{
					KnownShapes.Clear();
					numshapes = 0;
					pictureBox3.Image = null;
					ShapeNameTextBox.Text = "Shape Name";
					ShapeIndexTextBox.Text = "0";
				}
		}
	}
}
